﻿// $Id: DownloadPlugin.cs 19 2008-03-24 19:29:57Z arcao $
//
// Copyright (C) 2008 Martin "Arcao" Sloup <arcao@arcao.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;

namespace OSD.PluginBase
{
    /// <summary>
    /// Abstraktni trida pro DownloadPlugin. Kazda trida pro vytvoreni DownloadPluginu musi zdedit tuto tridu.
    /// </summary>
    public abstract class DownloadPlugin : Plugin
    {
        /// <summary>
        /// Konstruktor tridy s nastavenim tridy, ktera se stara o nastaveni
        /// </summary>
        /// <param name="settings">trida s nastavenim</param>
        public DownloadPlugin(Settings settings) : base(settings) {}

        /// <summary>
        /// Vraci true, pokud DownloadPlugin implementujici urcity server ma premiove ucty 
        /// </summary>
        public abstract bool HasPremiumAccount { get; }

        /// <summary>
        /// Zjisti, zda zadane url je schopne plugin stahnout
        /// </summary>
        /// <param name="url">url se souborem, ktery chceme stahnout</param>
        /// <returns>true, pokud plugin dokaze souboir na prislusnem url stahnout</returns>
        public abstract bool IsSuitableUrl(String url);

        /// <summary>
        /// Vraci Download tridu, ktera se postara o stazeni souboru
        /// </summary>
        /// <param name="url">url se souborem, ktery se bude stahovat</param>
        /// <returns>Download tridu, ktera se postara o proces stahovani</returns>
        public abstract Download GetDownloadForUrl(String url);
    }
}